from StringIO import StringIO
from Products.CMFCore.utils import getToolByName
from Products.Archetypes import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.MyNetwork.config import PROJECTNAME, GLOBALS

EXPORT_ACTION = 'ExportNetwork'

# not used - just for reference
def addAction(self, out):
     """add the export button to Network Folders"""
     
     print >> out, "Dealing with additions of portal actions"
     
     ap = getToolByName(self, 'portal_actions')

     ap.addAction(
          category='document_actions',
          id= EXPORT_ACTION,
          permission='View',
          name='Export this network',
          action='string:${object_url}/export_crap',
          condition='python:object.isNetworkFolder()',
          visible=1,
          )
     print >> out, '    added %s to portal actions.' % EXPORT_ACTION
     print >> out, "Done with portal actions"


# not used - just for reference          
def removeAction(self, out):
     """Remove the action we added"""

     print >> out, "Dealing with removal of portal actions"
     
     ap = getToolByName(self, 'portal_actions')
     actions = list(ap._actions)
     keep = list()
     for action in actions:
          if action.id != EXPORT_ACTION:
               keep.append(action)
               print >> out, "    let's keep '%s'." % (action.id)
          else:
               print >> out, "    will now remove '%s'." % (action.id)

     ap._actions = tuple(keep)
     print >> out, "Done with removal of portal actions"


def addToFactoryTool(self, out):
     print >> out, 'portal_factory modifications started.'
     
     ftool = getToolByName(self, 'portal_factory')
     
     if ftool:
          p_types = ftool.getFactoryTypes().keys()
               
     for p in [typeDict['portal_type'] for typeDict in listTypes(PROJECTNAME)]:
          if p not in p_types:
               p_types.append(p)
               ftool.manage_setPortalFactoryTypes(listOfTypeIds=p_types)
               print >> out, '    %s now uses portal_factory' % p
                    
     print >> out, 'portal_factory modifications completed.'


def install(self):
     """Install content types, enable the portal factory"""

     out = StringIO()

     print >> out, "Installing %s" % PROJECTNAME

     classes = listTypes(PROJECTNAME)
     installTypes(self, out,
                  classes,
                  PROJECTNAME)
     print >> out, "Installed types"

     install_subskin(self, out, GLOBALS)
     print >> out, "installed subskin"

     addToFactoryTool(self, out)

     # these next lines imports stuff in xml-file
     tool = getToolByName(self, 'portal_setup')
     tool.runAllImportStepsFromProfile("profile-Products.%s:default" % PROJECTNAME, purge_old=False)
               
     return out.getvalue()


# not used - just for reference
#def uninstall(self):
#     out = StringIO()
#     #removeAction(self, out)
#     print >> out, 'Uninstalled %s.' % PROJECTNAME
#     
#     return out.getvalue()
#
