## Script (Python) "bibliography_export"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=format='BibTex', output_encoding=None, eol_style=False
##title=
##

request = container.REQUEST
RESPONSE =  request.RESPONSE

RESPONSE.setHeader('Content-Type', 'application/octet-stream')
RESPONSE.setHeader('Content-Disposition', 'attachment; filename=%s' % context.getId() + '_' + context.getPortalTypeName() + '.dot')

def my_filter(item):
    item = item.replace(' ', '_')
    return item

output = ''

for field in context.Schema().filterFields(isMetadata=1):
    content = field.getAccessor(context)()
    if content:
        output += '# %s: %s;\n' % (
            my_filter(field.getName()),
            my_filter(str(content))
            )


output += '\ndigraph %s {\n\n' % (my_filter(context.Title()))

output += '    node [ shape = ellipse ];'

for node in context.nodes():
    if content:
        output += ' %s' % (my_filter(node.Title()))

output += ';\n\n'
        
for edge in context.edges():
    if content:
        output += '    %s -> %s [ label = "%s" ];\n' % (
            my_filter(edge.getNode_a().Title()),
            my_filter(edge.getNode_b().Title()),
            my_filter(edge.getId())
            )

output += '\n}'

return output
